--
-- ClearAFK, Designed-By: Nightness|Eonar
--
ClearAfk_Options = {
	UseButton = true,
};

local frame = CreateFrame("FRAME", "ClearAfkEventFrame");
frame:RegisterEvent("WORLD_MAP_UPDATE");
frame:RegisterEvent("PLAYER_FLAGS_CHANGED");

local clickThroughFrame = CreateFrame("Frame", "ClearAfkFrame", UIParent);
clickThroughFrame:SetBackdrop({ 
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
  edgeFile = nil, tile = false, tileSize = 0, edgeSize = 0, 
  insets = { left = 0, right = 0, top = 0, bottom = 0 }
});
clickThroughFrame:Hide();
clickThroughFrame:SetWidth(UIParent:GetWidth() * 2);
clickThroughFrame:SetHeight(UIParent:GetHeight() * 2);
clickThroughFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
clickThroughFrame:RegisterForDrag();

local button = CreateFrame("Button", "ClearAfkButton", UIParent, "SecureActionButtonTemplate,ActionButtonTemplate");
button:SetAttribute("type", "macro");
button:SetAttribute("macrotext", "/afk");
button:SetText("Clear AFK");
button:SetHighlightTexture(nil);
button:SetPushedTexture(nil);
button:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Background");
button:SetWidth(UIParent:GetWidth() * 2);
button:SetHeight(UIParent:GetHeight() * 2);
button:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
button:SetScript("PostClick", function (self, buttonName, isDown)
	button:Hide();
end);

local function UpdateAfk(control)
	if (UnitIsAFK("player")) then
		control:SetFrameStrata("BACKGROUND");		
		control:Show();
	else
		control:Hide();
	end
end

local function UseClickThrough()	
	ClearAfk_Options.UseButton = false;
	button:Hide();
	UpdateAfk(clickThroughFrame);
end

local function UseButton()	
	ClearAfk_Options.UseButton = true;
	clickThroughFrame:Hide();
	UpdateAfk(button);
end

local function DisplaySlashHelp()
	DEFAULT_CHAT_FRAME:AddMessage("|cFF69CCF0ClearAfk|r commands:")
	DEFAULT_CHAT_FRAME:AddMessage("    |cFFFFFF78 /clearafk clicks|r     - Left clicks clear AFK")
	DEFAULT_CHAT_FRAME:AddMessage("    |cFFFFFF78 /clearafk noclicks|r - Clicks do not clear AFK")
end

function ClearAfk_SlashCommand(msg)
    if ( msg and strlower(msg) == "noclicks" ) then
		UseClickThrough();
    elseif ( msg and strlower(msg) == "clicks" ) then
		UseButton();
    elseif ( msg ) then
		DisplaySlashHelp();
	end
end

SlashCmdList["ClearAfk"] = ClearAfk_SlashCommand
SLASH_ClearAfk1 = "/CLEARAFK"

frame:SetScript("OnEvent", function (self, event, ...)
	local control;
	if (ClearAfk_Options.UseButton == true) then
		clickThroughFrame:Hide();
		control = button;
	else
		button:Hide();
		control = clickThroughFrame;
	end
	UpdateAfk(control);
end);
